Subject: [BUG] "git range-diff" does not know X^! is a valid range

From: Junio C Hamano <[email-masked]>
Date: Tue, 02 Apr 2024 10:45:46 -0700

When cherry-picking an existing commit X to a different base, which
may have resulted in conflicts that needed a fix-up, you would want
to be able to compare X~1..X and HEAD~1..HEAD and naturally, we
would expect "range-diff" to have a handy way to allow giving the
command without having to type the overly long branch name X twice.

Individual "diff" for these two ranges are easy to obtain without
repeating X:

    $ git diff X^!
    $ git diff HEAD^!

The "git range-diff" however does not understand that X^! is a valid
range X~1..X.  This command throws an error and ...

    $ git range-diff refs/merge-fix/ew/khash-to-khashl^! HEAD^!
    fatal: need two commit ranges

... to add insult to injury, it shows the huge "git range-diff -h"
output after that.

Any takers?